/*
 * ConectivityMatrix.cpp
 *
 *  Created on: 22.10.2009
 *      Author: hartman
 */

#include "Graph.h"
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <queue>
#include <vector>
#include <list>
#include <stack>
#include <iterator>
#include <math.h>
#include <pthread.h>
#include <time.h>
#include <omp.h>
#include <time.h>

#define DEBUG false
#define INDICATION false

#define NN_INITIAL 0
#define NN_ASSORTATIVE 1
#define NN_DISASSORTATIVE 2
#define NN_CHAOTIC 3

struct MaxStep
{
	int start;
	int max;
};

Graph::Graph(SymMatrix<bool> *mat)
{
	data = *mat;

//	cout << "Undirected graph:" << endl;
#if (DEBUG)
	cout << data.to_s();
#endif

	initialSetttings();
}


Graph::Graph(SymMatrix<bool> *mat, SymMatrix<int> *dmat)
{
	if (mat != NULL)
		data = *mat;

	initialSetttings();

	D = dmat;

}

//Graph::Graph(char* amatrix, int arows, int acols)
//{
//	data.size() = acols;
//	data.size() = arows;
//	data.len() = (data.size()*(data.size() + 1)) / 2;
//	data = amatrix;
//
//	initialSetttings();
//
//	//printMatrix(10);
//}
//
//Graph::Graph(string filename, bool symmetric, double threshold) {
//	FILE* datafile = fopen ( filename.c_str() , "rb" );
//
//	if (datafile != NULL)
//	{
//    	data.size() = 0.0;
//    	data.size() = 0.0;
//
//    	int result = fread (&data.size(),sizeof data.size(),1,datafile);
//    	result = fread (&data.size(),sizeof data.size(),1,datafile);
//
//		#if DEBUG
//			cout << "Matice je velka " << data.size() << ":" << data.size() << endl;
//		#endif
//
//		if (symmetric)
//		{
//			// set data.len() of working array
//			data.len() = (data.size()*(data.size() + 1)) / 2;
//
//			// create array and
//			data = new char[data.len()];
//	    	double* aux = new double[data.size()];
//
//	    	// global index into data array
//	    	int index = 0;
//
//	    	// reading data
//	    	int block_size = 0;
//	    	numedges = 0;
//
//	    	for (int i = 0; i < data.size(); i++)
//	    	{
//	    		// size of readed array
//	    		int read_size = data.size() - i;
//
//	    		// read
//	    		result = fread (aux,sizeof (double),read_size,datafile);
//
//	    		// thresholding
//	    		for (int j = 0; j < read_size; j++)
//	    		{
//	    			//double d = -0.5*log(1-aux[j]*aux[j]);
//	    			//double d = (aux[j] < 0) ? -aux[j]:aux[j];
//	    			double d = fabs(aux[j]);
//	    			if (d > threshold)
//	    			{
//	    				data[index++] = 1;
//	    				numedges++;
//	    			}
//	    			else
//	    			{
//	    				data[index++] = 0;
//	    			}
//	    			//data[index++] = (aux[j] > threshold) ? 1:0;
//	    		}
//
//				#if DEBUG
//					//printTriangular();
//				#endif
//	    	}
//
//	    	delete aux;
//
//			#if DEBUG
//				cout << "Final index:" << index << endl;
//			#endif
//		}
//		else
//		{
//			// set data.len() of working array
//			data.len() = (data.size()*(data.size() + 1)) / 2;
//
//			// create array and
//			data = new char[data.len()];
//	    	double* aux = new double[data.size()];
//
//	    	// global index into data array
//	    	int index = 0;
//
//	    	// reading data
//	    	int block_size = 0;
//	    	numedges = 0;
//
//	    	for (int i = 0; i < data.size(); i++)
//	    	{
//	    		// jump over prediagonal part and
//	    		fseek(datafile, (sizeof (double))*i, SEEK_CUR);
//	    		// size of readed array
//	    		int read_size = data.size() - i;
//
//	    		// read
//	    		result = fread (aux,sizeof (double),(data.size() - i),datafile);
//
//	    		// thresholding
//	    		for (int j = 0; j < read_size; j++)
//	    		{
//	    			if (aux[j] > threshold)
//	    			{
//	    				data[index++] = 1;
//	    				numedges++;
//	    			}
//	    			else
//	    			{
//	    				data[index++] = 0;
//	    			}
//	    			//data[index++] = (aux[j] > threshold) ? 1:0;
//	    		}
//
//	    		block_size += data.size() - i;
//
//				#if DEBUG
//					// printTriangular();
//				#endif
//	    	}
//
//	    	delete aux;
//
//			#if DEBUG
//				cout << "Final index:" << index << endl;
//			#endif
//	    }
//
//		#if DEBUG
//			printMatrix(10);
//		#endif
//
//
//		initialSetttings();
//
//		fclose (datafile);
//    }
//    else
//    {
//    	cout << "File "<<  filename << " not loaded!!!" << endl;
//    }
//}

void Graph::initialSetttings()
{
	degrees = NULL;
	nearestNeighbors = NULL;
	numedges = -1;
	INFTY = data.size() + 1;
	INFTY_SUM = data.size()*INFTY;
	betweenessVector = NULL;
	randWalkBetweenessVector = NULL;
	eigenvectorBetweenessVector = NULL;
	clusteringVector = NULL;
	componentsList = NULL;
	closenessVector = NULL;
	visited = NULL;

	D = NULL;
	degreesGet = false;
	nnGet = false;
	clusteringGet = false;
	betweenessGet = false;
	componentsGet = false;
	closenessGet = false;
	randWalkBetweenessGet = false;
	eigenvectorBetweenessGet = false;
	averageDegree = NO_DEGREE;
}

Graph::~Graph() {
	if (!degreesGet && degrees != NULL)
		delete degrees;
	if (!nnGet && nearestNeighbors != NULL)
		delete nearestNeighbors;
	if (!clusteringGet && clusteringVector != NULL)
		delete clusteringVector;
	if (!betweenessGet && betweenessVector != NULL)
		delete betweenessVector;
	if (!componentsGet && componentsList != NULL)
		delete componentsList;
	if (!eigenvectorBetweenessGet && eigenvectorBetweenessVector != NULL)
		delete eigenvectorBetweenessVector;
	if (!randWalkBetweenessGet && randWalkBetweenessVector != NULL)
		delete randWalkBetweenessVector;
	if (visited != NULL)
		delete visited;
}

char Graph::operator() (int i, int j)
{
	return (i <= j) ? (data[i*data.size() - (i*(i+1)/2) + j]):(data[j*data.size() - (j*(j+1)/2) + i]);
}

int Graph::numerOfTriangles(int nodeIndex)
{
	// auxiliary array with one on neighbor positions
	char* nodeNeighs = new char[data.size()];
	for (int j = 0; j < data.size(); j++)
	{
		nodeNeighs[j] = (this->operator ()(nodeIndex,j) == 1) ? 1:0;
	}


	// go through matrix and sum suited elements (i.e. those [i,j] for which a_{nodeIndex,j} == 1)
	int sum = 0;
	int i = 0;
	int rlen = data.size();
	int indx = 0;

	while (indx < data.len())
	{
		// jump over non-interesting data.size()
		while (i < data.size() && nodeNeighs[i] == 0)
		{
			i++;
			indx += rlen;
			rlen--;
		}

		// for jumping over end
		if (i >= data.size())
			break;

		// go through elements of row
		for (int j = i; j < data.size(); j++)
		{
			// for nonexcluded and non-zero elements
			if (nodeNeighs[j] != 0 && data[indx] != 0)
			{
				sum += 2; // sum this and symmetric one
			}
			indx++;
		}

		// jump to next row
		i++;
		rlen--;
	}

	if (nodeNeighs != NULL)
		delete nodeNeighs;

	return sum;
}

double Graph::clusteringCoeficient()
{

	clock_t start, finish;
	start = clock();

	double sum = 0.0;

	// specify node degrees
	if (degrees == NULL)
		nodeDegrees();

	if (clusteringVector == NULL)
	{
		clusteringVector = new double[data.size()];

		// count CC
		for (int i = 0; i < data.size(); i++)
		{
			int k = degrees[i];
			if (k >= 2)
			{
				double a = numerOfTriangles(i);
				double ci = a/ (double) (k*k-k);
				sum += ci;
				clusteringVector[i] = ci;
			}
			else
			{
				clusteringVector[i] = 0;
			}

			#if (INDICATION)
				cout << "\r Clustering coeficient:" << i << "/" << data.size();
				cout.flush();
			#endif
		}

		#if (INDICATION)
			cout << endl;
		#endif
	}
	else
	{
		for (int i = 0; i < data.size(); i++)
			sum += clusteringVector[i];
	}


	double c = (1/ (double) data.size())*sum;

	finish = clock();
	cout << ( (finish - start) ) << "\n";
	return c;
}

int* Graph::nodeDegrees()
{
	degreesGet = true;

	if (degrees == NULL)
	{
		degrees = new int[data.size()];

		for (int i = 0; i < data.size(); i++)
		{
			degrees[i] = 0;
			for (int j = 0; j < data.size(); j++)
			{
				if (this->operator ()(i,j) == 1)
					degrees[i]++;
			}

			#if (INDICATION)
				cout << "\r Degrees:" << i << "/" << data.size();
				cout.flush();
			#endif

		}


		#if (INDICATION)
			cout << endl;
		#endif

		#if (DEBUG)
			cout << "Node Degrees:" << endl;
			for (int i = 0; i < data.size(); i++)
			{
				cout << degrees[i] << " ";
			}
			cout << endl;
		#endif
	}

	return degrees;
}

void Graph::sortArrayByDegrees(double* array)
{
    for (int i = 1; i < data.size(); i++)
    {
        int deg = degrees[i];
        double elem = array[i];
        int j = i - 1;
        while (j >= 0 && degrees[j] > deg)
        {
        	degrees[j + 1] = degrees[j];
        	array[j + 1] = array[j];
            j = j - 1;
        }
        degrees[j + 1] = deg;
        array[j + 1] = elem;
    }
}

double* Graph::nodeNearestNeighbors()
{
	nnGet = true;

	// count nodes' degrees
	nodeDegrees();

	if (nearestNeighbors == NULL)
	{
		#if DEBUG
			cout << "Degrees:" << endl;
			for (int i = 0; i < data.size(); i++)
				cout << degrees[i] << " ,";
			cout << endl;
		#endif

		// enumerate average nearest neighbours
		nearestNeighbors = new double[data.size()];

		for (int i = 0; i < data.size(); i++)
		{
			nearestNeighbors[i] = 0.0;

			if (degrees[i] != 0)
			{
				for (int j = 0; j < data.size(); j++)
				{
					if (this->operator ()(i,j) == 1)
						nearestNeighbors[i] += degrees[j];
				}
				nearestNeighbors[i] = nearestNeighbors[i] / (double) degrees[i];
			}
		}

		#if DEBUG
			cout << "nearestNeighbors:" << endl;
			for (int i = 0; i < data.size(); i++)
				cout << "(" << degrees[i] << ":" << nearestNeighbors[i] << ") ,";
			cout << endl;
		#endif
	}

	return nearestNeighbors;
}


int Graph::getSize()
{
	return data.size();
}

SymMatrix<int>* Graph::distanceMatrix()
{
	if (D != NULL)
		return D;

	// there is never path longer than this
	int infinite = data.size() + 1;
	int rowsize = data.size();

	// preparation work
	// new matrix with no element to init
	D = new SymMatrix<int>(data.size(),NULL);
	int j = 0;	// just indicator of already passed part of row - not an index
	for (int i = 0; i < data.len(); i++)
	{
		#if (INDICATION)
			cout << "\r Distance Matrix (prep):" << i << "/" << data.len();
			cout.flush();
		#endif

		// diagonal elements are not modified
		if (j != 0)
		{
			// just zero should be converted into infinite
			if (data[i] == 0)
			{
				(*D)[i] = infinite;
			}
			else
			{
				(*D)[i] = 1;  // we know now that on data[i] there is one
			}
		}
		else
		{
			(*D)[i] = 0;  // we know now that on data[i] there is one
		}

		j++;
		if (j >= rowsize)
		{
			j = 0;
			rowsize--;
		}
	}

	int ij,ji,ik,kj;
	int irow,jrow,krow;

	for (int k = 0; k < data.size(); k++)
	{
		krow = k*data.size() - (k*(k+1)/2);

		for (int i = 0; i < data.size(); i++)
		{
			irow = i*data.size() - (i*(i+1)/2);
			ik = (i <= k) ? irow + k:krow + i;

			for (int j = 0; j <= i; j++)
			{
				jrow = j*data.size() - (j*(j+1)/2);
				//ij = (i <= j) ? irow + j:jrow + i;
				ij = jrow + i;
				ji = jrow + i;
				kj = (k <= j) ? krow + j:jrow + k;

				if ((*D)[ij] > ((*D)[ik] + (*D)[kj]))
				{
					(*D)[ij] = (*D)[ik] + (*D)[kj];
					(*D)[ij] = (*D)[ji];
				}
			}
		}
	}

	return D;
}

SymMatrix<int>* Graph::distanceMatrixPaths()
{

	if (D->specified())
	{
		// TODO create paths
		return D;
	}

	// creation of predecessor matrix for paths
	predInPath = new int[data.len()];

	// there is never path longer than this
	int infinite = data.size() + 1;

	// preparation work
	D = new SymMatrix<int>(data.size(),NULL);
	int rowsize = data.size();
	int j = 0;	// just indicator of already passed part of row - not an index
	for (int i = 0; i < data.len(); i++)
	{
		#if (INDICATION)
			cout << "\r Distance Matrix (prep):" << i << "/" << data.len();
			cout.flush();
		#endif

		// diagonal elements are not modified
		if (j != 0)
		{
			// just zero should be converted into infinite
			if (data[i] == 0)
			{
				(*D)[i] = infinite;
			}
			else
			{
				(*D)[i] = 1;  // we know now that on data[i] there is one
			}

			predInPath[i] = 0;
		}
		else
		{
			(*D)[i] = 0;  // diagonal element
			predInPath[i] = 0;
		}

		j++;
		if (j >= rowsize)
		{
			j = 0;
			rowsize--;
		}
	}

	int ij,ji,ik,kj;
	int irow,jrow,krow;

	for (int k = 0; k < data.size(); k++)
	{
		krow = k*data.size() - (k*(k+1)/2);

		for (int i = 0; i < data.size(); i++)
		{
			irow = i*data.size() - (i*(i+1)/2);
			ik = (i <= k) ? irow + k:krow + i;

			for (int j = 0; j <= i; j++)
			{
				jrow = j*data.size() - (j*(j+1)/2);
				//ij = (i <= j) ? irow + j:jrow + i;
				ij = jrow + i;
				ji = jrow + i;
				kj = (k <= j) ? krow + j:jrow + k;

				if ((*D)[ij] > ((*D)[ik] + (*D)[kj]))
				{
					(*D)[ij] = (*D)[ik] + (*D)[kj];
					(*D)[ji] = (*D)[ij];
					predInPath[ij] = 0;
				}
			}
		}
	}

	return D;
}

double Graph::averageShortestPath()
{
	double result = -1;

	distanceMatrix();

//	// test for existence of component
//	bool component = false;
//	for (int i = 0; i < D->len(); i++)
//	{
//		if ((*D)[i] > D->size())
//			component = true;
//
//		#if (INDICATION)
//			cout << "\r Component:" << i << "/" << data.len();
//			cout.flush();
//		#endif
//	}

	// do sum of a matrix - there are zeros on diagonal and both elements should be taken twice (triangular storage)
	int sum = 0;
	double n = 0;
	for (int i = 0; i < D->len(); i++)
	{
		int d = (*D)[i];
		if (d < D->size())
			sum += 2*d;
		else
			n++;

		#if (INDICATION)
			cout << "\r Average SP:" << i << "/" << data.len();
			cout.flush();
		#endif
	}
	double divisor = ((double)D->size())*(D->size()-1) - n;
	result = (1/divisor)*sum;

	return result;
}

double Graph::efficiency()
{
	double result = -1;
	distanceMatrix();

	// zero distances are only on diagonal
	double sum = 0.0;
	for (int i = 0; i < D->len(); i++) {
		int d = (*D)[i];
		// only for d < inf (i.e. < data.size()) and nonzero (for it add zero ;-))
		if (d < D->size() && d != 0)
		{
			sum += 2 / (double) d;
		}

		#if (INDICATION)
			cout << "\r Efficiency:" << i << "/" << data.len();
			cout.flush();
		#endif
	}
	result = (1 / ((double) (D->size()) * (D->size() - 1))) * sum;

	return result;
}

double Graph::getNumberOfEdges()
{
	if (numedges < 0)
	{
		numedges = 0;

		// can sum all the element of array twice (zero elements are counted like zero anyway)
		// assume all elements on diagonal is 0, so we can sum it all and then make it twice
		for (int i = 0; i < data.len(); i++)
		{
			numedges += (int) data[i];
		}
	}

	return numedges;
}

double Graph::density()
{
	// \rho = |E|/(n \choose 2)

	numedges = getNumberOfEdges();

	double allEdges = (double) data.size()*(data.size() - 1) / 2.0;

	return ((double) numedges) / allEdges;
}

double Graph::assortativeCoeficient()
{
	double result = -1;

	nodeDegrees();

	int sum1d = 0;
	double sum2 = 0.0;
	int sum3d = 0;

	int rowbegin = 0;
	int i = 0; // row index
	int j = rowbegin; // column index

	int nonZeroElements = 0;

	// iterate over all edges
	for (int k = 0; k < data.len(); k++)
	{
		// if there is an edge
		if (data[k] == 1)
		{
			// count down sum
			sum1d += degrees[i] + degrees[j];
			sum2 += pow((double) degrees[i],2) + pow((double) degrees[j],2);
			sum3d += degrees[i] * degrees[j];

			nonZeroElements++;
		}

		j++;
		if (j >= data.size())
		{
			rowbegin++;
			j = rowbegin;
			i++;
		}

		#if (INDICATION)
			cout << "\r Assortative coefficient:" << k << "/" << data.len();
			cout.flush();
		#endif
	}

	double sum1 = (double) sum1d;
	double sum3 = (double) sum3d;

	// update number of edges
	if (numedges == -1)
		numedges = nonZeroElements;

	// inverse number of edges
	double invl = 1/ (double) numedges;

	// assortative coeficient itself from Newman
	result = (invl * sum3 - pow(invl*0.5*sum1,2))/(invl*0.5*sum2 - pow(invl*0.5*sum1,2));

	return result;
}


double Graph::closeness()
{
	// enumerate distance matrix to know all shortest paths
	double result = -1;
	distanceMatrix();

	// for each vertex count paths to others - sum all elements of distance matrix on one row

	// initialize sum of distances and degrees
	int* distsum = new int[data.size()];
	int* sizes = new int[data.size()];
	for (int i = 0; i < data.size(); i++)
	{
		distsum[i] = 0;
		sizes[i] = data.size();
	}

	// count down distance sum and size of neighborhood
	int rowsize = data.size();
	int j = 0;
	int k = 0;
	for (int i=0; i < data.len(); i++)
	{
		if ((*D)[i] >= INFTY)
		{
			sizes[k]--;
			if (j != 0)
				sizes[k+j]--;

			// for other approach
//			distsum[k] = INFTY_SUM;
//			if (j != 0)
//				distsum[k+j] = INFTY_SUM;
//			continue;
		}
		if ((*D)[i] != INFTY)
		{
			distsum[k] += (*D)[i];
			if (j != 0)
				distsum[k+j] += (*D)[i];
		}

		j++;
		if (j >= rowsize)
		{
			j = 0;
			rowsize--;
			k++;
		}

		#if (INDICATION)
			cout << "\r Closeness (sum):" << i << "/" << data.len();
			cout.flush();
		#endif
	}

	//printVector(distsum,10);
	//printVector(sizes,10);

	// apply inverse
	closenessVector = new double[data.size()];
	for (int j =0; j < data.size(); j++)
	{
		if (distsum[j] == 0)
		{
			closenessVector[j] = 0;
		}
		else
		{
//			invdistsum[j] = (sizes[j] - 1) / ((double)distsum[j]);
			closenessVector[j] = 1 / ((double)distsum[j]);
		}

		#if (INDICATION)
			cout << "\r Closeness (inv):" << j << "/" << data.size();
			cout.flush();
		#endif
	}

	//printVector(invdistsum,10);

	// sum all the sums
	double sum = 0.0;
	for (int j =0; j < data.size(); j++)
		sum += closenessVector[j];

	result = (1/((double) data.size()))*sum;

	return result;
}

double Graph::betweenessParallel(int cpunum)
{
	int *iret = new int[cpunum];
	int **steps = new int*[cpunum];
    pthread_t *threads = new pthread_t[cpunum];


	for (int i = 0; i < cpunum; i++)
	{
		steps[i] = new int[2];
		steps[i][0] = cpunum;
		steps[i][1] = i;
		iret[i] = pthread_create( &threads[i], NULL, Graph::betweenessParallelStepInvoker, new thread_fun_args(this,steps[i]));
	}


	for (int i = 0; i < cpunum; i++)
	{
		pthread_join( threads[i], NULL);
	}


	long double sum = 0.0;

	for (int i = 0; i < data.size(); i++)
	{
		sum += betweenessVector[i];
	}

	long double result = (1/((long double) data.size()))*sum;

	return result;
}

void* Graph::betweenessParallelStepInvoker(void *args)
{
	thread_fun_args* tf_args = static_cast<thread_fun_args*>(args) ;
	Graph* This = tf_args->This ;
	void* fargs = tf_args->actual_arg ;

	void* result = This->betweenessParallelStep(fargs);

	delete tf_args ;
	return result ;
}

void* Graph::betweenessParallelStep(void *args)
{
	// TODO strongly rethink

	thread_fun_args* tf_args = static_cast<thread_fun_args*>(args);
	void* fargs = tf_args->actual_arg;
	int* iargs = (int*) fargs;
	int step = iargs[0];
	int start = iargs[1];

	// parallel betweenness
	long double* auxBetweenessVector = new long double[data.size()];
	for (int i = 0; i < data.size(); i++)
		auxBetweenessVector[i] = 0.0;

	ULLONG_SUM_TYPE* sigma = new ULLONG_SUM_TYPE[data.size()];
	LLONG_SUM_TYPE* d = new LLONG_SUM_TYPE[data.size()];
	long double* delta = new long double[data.size()];
	list<int>* P = new list<int>[data.size()];

	for (int s = start; s < data.size(); s += step)
	{

		#if (INDICATION)
			cout << "\r Betweeness:" << s << "/" << data.size();
			cout.flush();
		#endif

		stack<int> S;

		for (int j = 0; j < data.size(); j++)
		{
			sigma[j] = 0;
			d[j] = -1;
		}
		sigma[s] = 1;
		d[s] = 0;


		queue<int> Q;
		Q.push(s);  // maybe push_back

		while (!Q.empty())
		{
			int v = Q.front();
			Q.pop();
			S.push(v);

			// move to next neighbor
			int w = 0;

			while (w < data.size())
			{
				// find neighbor
				while (w < data.size() && this->operator ()(v,w) == 0)
					w++;

				// if no neigh exit
				if (w >= data.size())
					break;

				if (d[w] < 0)
				{
					Q.push(w);
					d[w] = d[v] + 1;
				}

				if (d[w] == d[v] + 1)
				{
					sigma[w] = sigma[w] + sigma[v];
					P[w].push_back(v);
				}

				w++; // shift to next
			}


		}

		for (int j = 0; j < data.size(); j++)
			delta[j] = 0.0;

		#if (DEBUG)
			cout << "Sigmas:" << endl;
			for (int j = 0; j < data.size(); j++)
				cout << sigma[j] << " ";
			cout << endl;
		#endif


		while (!S.empty())
		{
			int w = S.top();
			S.pop();
			list<int>::iterator it;

			#if (DEBUG)
				cout << "Prvek:" << w << endl;
			#endif

			for (it = P[w].begin() ; it != P[w].end(); it++)
			{
				int v = *it;  // int v = (int) *it
				delta[v] = delta[v] + ((long double)sigma[v]/(long double)sigma[w])*(1.0+delta[w]);

				#if (DEBUG)
					cout << "\t "<< delta[v] << "=" << sigma[v] << "/" << sigma[w] << "*(1 + " << delta[w] << ")" << endl;
					cout << "\t Cb = "<< auxBetweenessVector[w] << endl;
				#endif
			}

			if (w != s)
			{
				auxBetweenessVector[w] = auxBetweenessVector[w] + delta[w];
			}
		}

		// delete aux data
		for (int i = 0;  i < data.size(); i++)
			P[i].clear();
	}

	betweenessVector = new double[data.size()];
	for (int i = 0; i < data.size(); i++)
		betweenessVector[i] = (double) auxBetweenessVector[i];


	delete[] P;
	delete sigma;
	delete d;
	delete delta;

	return NULL;
}

/*!
 *	Betweeness based on eigenvector for given graph.
 *
 * @return Random walk betweeness.
 */
// double Graph::eigenvectorBetweeness()
// {
// 	double* mat = new double[data.len()];
// 	for (int i = 0; i < data.len(); i++)
// 	{
// 		mat[i] = (double) data[i];
// 	}


// 	double* d = MatrixOperations::maxeigenvectorTri(mat,data.size());

// 	//printVector(d, data.size());

// 	// calculate norm
// 	double ssum = 0;
// 	double norm = 0;
// 	for(int i = 0; i <= data.size()-1; i++)
// 	{
// 		ssum += d[i];
// 		norm += fabs(d[i])*fabs(d[i]);
// 	}
// 	int ssign = ((ssum > 0) ? 1 : -1);
// 	norm = sqrt(norm)*ssign;

// 	//cout << norm << endl;

// 	eigenvectorBetweenessVector = new double[data.size()];
// 	for(int i = 0; i <= data.size()-1; i++)
// 		eigenvectorBetweenessVector[i] = (double) d[i] / (double) norm;

// 	double sum = 0.0;

// 	//cout << "eigBetweenness" << endl;
// 	for (int i = 0; i < data.size(); i++)
// 	{
// 		//cout << eigenvectorBetweenessVector[i] << "  ";
// 		sum += eigenvectorBetweenessVector[i];
// 	}
// 	//cout << endl;

// 	double result = (1/((long double) data.size()))*sum;

// 	return result;
// }

// double Graph::randWalkBetweeness()
// {
// 	//
// 	// Implement D - A (diag(degrees) - Adjacency Matrix) with last row and column removal
// 	//
// 	// possibly enumerate degrees (if they are not)
// 	nodeDegrees();

// 	// determine adjacency matrices for components
// 	components();
// 	int compNum = componentsList->size();

// 	if (compNum == 1)
// 	{
// 		int newlen = ((data.size() - 1)*data.size()) / 2;
// 		// adjacency matrix
// 		double* A = new double[newlen];
// 		int k = 0;
// 		int l = 0;
// 		for (int i = 0; i < data.size() - 1; i++)
// 		{
// 			// for diagonal element
// 			A[l] = degrees[i] - data[k++];
// 			l++;

// 			// for others
// 			for (int j = i+1; j < data.size() - 1; j++)
// 			{
// 				A[l] = -data[k++];
// 				l++;
// 			}

// 			// let the last column be excluded
// 			k++;
// 		}

// 		// enumerate inverse of matrix and to result input row and column with zeros
// 		double* T;
// 		T = MatrixOperations::inverseTriPlusDim(A,data.size() - 1);
// 		if (T == NULL)
// 		{
// 			cout << "Error" << endl;
// 			return 0;
// 		}

// 	//    cout << "Result " << endl;
// 	//    k = 0;
// 	//    for(int i = 0; i < data.size(); i++)
// 	//    {
// 	//        for(int j = 0; j < i; j++)
// 	//        {
// 	//        	cout << "\t";
// 	//        }
// 	//
// 	//        for(int j = i; j < data.size(); j++)
// 	//        {
// 	//       		cout << T[k++] << "\t";
// 	//        }
// 	//        cout << endl;
// 	//    }
// 	//    cout << endl;

// 		// calculate C_bi
// 		randWalkBetweenessVector = new double[data.size()];
// 		long denom = data.size()*(data.size() - 1);

// 		// for each vertex
// 		for (int i = 0; i < data.size(); i++)
// 		{
// 			// append 4 for I_s^{st}=2 and I_t^{st}=2 considering 1/2 to be given out, for all pairs n-1
// 			double cbi = 2*(data.size() -1);

// 			// for all pairs s < t do enumeration
// 			for (int s = 0; s < data.size(); s++)
// 			{
// 				if (s != i)  // all I_{i == s}^{st} = 2
// 				{
// 					int is = (i <= s) ? i*data.size() - (i*(i+1)/2) + s:s*data.size() - (s*(s+1)/2) + i;
// 					for (int t = s + 1; t < data.size(); t++)
// 					{
// 						if (t != i)
// 						{
// 							int it = (i <= t) ? i*data.size() - (i*(i+1)/2) + t:t*data.size() - (t*(t+1)/2) + i;
// 							for (int j = 0; j < data.size(); j++)
// 							{
// 								if (this->operator ()(i,j) == 1)
// 								{
// 									int js = (j <= s) ? j*data.size() - (j*(j+1)/2) + s:s*data.size() - (s*(s+1)/2) + j;
// 									int jt = (j <= t) ? j*data.size() - (j*(j+1)/2) + t:t*data.size() - (t*(t+1)/2) + j;
// 									cbi = cbi + fabs(T[is] - T[it] - T[js] + T[jt]);
// 									// cout << cbi << " = " << T[is] << " - " << T[it] << " - " << T[js] << " + " << T[jt] << "\t ," << i << " " << j << " " << s << " " << t << " " << endl;
// 								}
// 							}
// 						}
// 					}
// 				}
// 			}

// 			cbi = cbi / (double) denom;
// 			randWalkBetweenessVector[i] = cbi;
// 		}
// 	}
// 	else
// 	{
// 		randWalkBetweenessVector = new double[data.size()];

// 		char** matrices = NULL;
// 		int** indices = NULL;
// 		int* sizes = NULL;
// 		int** subdegrees = NULL;
// 		getComponentMatrices(&matrices,&indices,&sizes,&subdegrees);

// 		// do calculation for each component - TODO
// 		for (int cp = 0; cp < compNum; cp++)
// 		{
// 			int n = sizes[cp];

// 			// isolated vertex => random walk betweenness is 0
// 			if (n == 1)
// 			{
// 				randWalkBetweenessVector[indices[cp][0]] = 0.0;
// 			}
// 			else
// 			{
// 				int newlen = ((n - 1)*n) / 2;
// 				// adjacency matrix
// 				double* A = new double[newlen];
// 				int k = 0;
// 				int l = 0;
// 				for (int i = 0; i < n - 1; i++)
// 				{
// 					// for diagonal element
// 					A[l] = subdegrees[cp][i] - matrices[cp][k++];
// 					l++;

// 					// for others
// 					for (int j = i+1; j < n - 1; j++)
// 					{
// 						A[l] = -matrices[cp][k++];
// 						l++;
// 					}

// 					// let the last column be excluded
// 					k++;
// 				}

// //					cout << "A: " << endl;
// //					k = 0;
// //					for(int i = 0; i < n-1; i++)
// //					{
// //						for(int j = 0; j < i; j++)
// //						{
// //							cout << "\t";
// //						}
// //
// //						for(int j = i; j < n-1; j++)
// //						{
// //							cout << A[k++] << "\t";
// //						}
// //						cout << endl;
// //					}
// //					cout << endl;

// 				// enumerate inverse of matrix and to result input row and column with zeros
// 				double* T;
// 				T = MatrixOperations::inverseTriPlusDim(A,n - 1);
// 				if (T == NULL)
// 				{
// 					cout << "Error" << endl;
// 					return -1;
// 				}

// //				cout << "Result " << endl;
// //				k = 0;
// //				for(int i = 0; i < n; i++)
// //				{
// //					for(int j = 0; j < i; j++)
// //					{
// //						cout << "\t";
// //					}
// //
// //					for(int j = i; j < n; j++)
// //					{
// //						cout << T[k++] << "\t";
// //					}
// //					cout << endl;
// //				}
// //				cout << endl;

// 				// calculate C_bi
// 				double* randwalkBetVector = new double[n];
// 				long denom = n*(n - 1);

// 				// for each vertex
// 				for (int i = 0; i < n; i++)
// 				{
// 					// append 4 for I_s^{st}=2 and I_t^{st}=2 considering 1/2 to be given out, for all pairs n-1
// 					double cbi = 2*(n -1);

// 					// for all pairs s < t do enumeration
// 					for (int s = 0; s < n; s++)
// 					{
// 						if (s != i)  // all I_{i == s}^{st} = 2
// 						{
// 							int is = (i <= s) ? i*n - (i*(i+1)/2) + s:s*n - (s*(s+1)/2) + i;
// 							for (int t = s + 1; t < n; t++)
// 							{
// 								if (t != i)
// 								{
// 									int it = (i <= t) ? i*n - (i*(i+1)/2) + t:t*n - (t*(t+1)/2) + i;
// 									for (int j = 0; j < n; j++)
// 									{
// 										if (this->operator ()(i,j) == 1)
// 										{
// 											int js = (j <= s) ? j*n - (j*(j+1)/2) + s:s*n - (s*(s+1)/2) + j;
// 											int jt = (j <= t) ? j*n - (j*(j+1)/2) + t:t*n - (t*(t+1)/2) + j;
// 											cbi = cbi + fabs(T[is] - T[it] - T[js] + T[jt]);
// 											// cout << cbi << " = " << T[is] << " - " << T[it] << " - " << T[js] << " + " << T[jt] << "\t ," << i << " " << j << " " << s << " " << t << " " << endl;
// 										}
// 									}
// 								}
// 							}
// 						}
// 					}

// 					cbi = cbi / (double) denom;
// 					randwalkBetVector[i] = cbi;
// 				}

// 				// place results to resulting array
// 				for (int i = 0; i < n; i++)
// 					randWalkBetweenessVector[indices[cp][i]] = randwalkBetVector[i];
// 			}
// 		}
// 	}

// 	double sum = 0.0;

// 	//cout << "rwBetweenness" << endl;
// 	for (int i = 0; i < data.size(); i++)
// 	{
// 		//cout << randWalkBetweenessVector[i] << endl;
// 		sum += randWalkBetweenessVector[i];
// 	}
// 	//cout << endl;

// 	double result = (1/((double) data.size()))*sum;

// 	return result;
// }

double Graph::betweeness()
{
	betweenessVector = new double[data.size()];
	for (int i = 0; i < data.size(); i++)
		betweenessVector[i] = 0.0;

	ULLONG_SUM_TYPE* sigma = new ULLONG_SUM_TYPE[data.size()];
	LLONG_SUM_TYPE* d = new LLONG_SUM_TYPE[data.size()];
	double* delta = new double[data.size()];
	list<int>* P = new list<int>[data.size()];

	for (int s = 0; s < data.size(); s++)
	{

		#if (INDICATION)
			cout << "\r Betweeness:" << s << "/" << data.size();
			cout.flush();
		#endif

		stack<int> S;

		for (int j = 0; j < data.size(); j++)
		{
			sigma[j] = 0;
			d[j] = -1;
		}
		sigma[s] = 1;
		d[s] = 0;


		queue<int> Q;
		Q.push(s);  // maybe push_back

		while (!Q.empty())
		{
			int v = Q.front();
			Q.pop();
			S.push(v);

			// move to next neighbor
			int w = 0;

			while (w < data.size())
			{
				// find neighbor
				while (w < data.size() && this->operator ()(v,w) == 0)
					w++;

				// if no neigh exit
				if (w >= data.size())
					break;

				if (d[w] < 0)
				{
					Q.push(w);
					d[w] = d[v] + 1;
				}

				if (d[w] == d[v] + 1)
				{
					sigma[w] = sigma[w] + sigma[v];
					P[w].push_back(v);
				}

				w++; // shift to next
			}


		}

		for (int j = 0; j < data.size(); j++)
			delta[j] = 0.0;

		#if (DEBUG)
			cout << "Sigmas:" << endl;
			for (int j = 0; j < data.size(); j++)
				cout << sigma[j] << " ";
			cout << endl;
		#endif


		while (!S.empty())
		{
			int w = S.top();
			S.pop();
			list<int>::iterator it;

			#if (DEBUG)
				cout << "Prvek:" << w << endl;
			#endif

			double wcoeff = (1.0+delta[w]) / ((double)sigma[w]);

			for (it = P[w].begin() ; it != P[w].end(); it++)
			{
				int v = *it;  // int v = (int) *it
				delta[v] = delta[v] + wcoeff*sigma[v];

				#if (DEBUG)
					cout << "\t "<< delta[v] << "=" << sigma[v] << "/" << sigma[w] << "*(1 + " << delta[w] << ")" << endl;
					cout << "\t Cb = "<< betweenessVector[w] << endl;
				#endif
			}

			if (w != s)
			{
				betweenessVector[w] = betweenessVector[w] + delta[w];
			}
		}

		// delete aux data
		for (int i = 0;  i < data.size(); i++)
			P[i].clear();
	}

	delete[] P;
	delete sigma;
	delete d;
	delete delta;

	double sum = 0.0;
	for (int i = 0; i < data.size(); i++)
		sum += betweenessVector[i];

	double result = (1/((double) data.size()))*sum;

	return result;
}

double Graph::betweenessMP()
{
	betweenessVector = new double[data.size()];
	for (int i = 0; i < data.size(); i++)
		betweenessVector[i] = 0.0;

	ULLONG_SUM_TYPE* sigma = new ULLONG_SUM_TYPE[data.size()];
	LLONG_SUM_TYPE* d = new LLONG_SUM_TYPE[data.size()];
	double* delta = new double[data.size()];
	list<int>* P = new list<int>[data.size()];

	//#pragma omp parallel for default(none)
	for (int s = 0; s < data.size(); s++)
	{

		#if (INDICATION)
			cout << "\r Betweeness:" << s << "/" << data.size();
			cout.flush();
		#endif

		stack<int> S;

		for (int j = 0; j < data.size(); j++)
		{
			sigma[j] = 0;
			d[j] = -1;
		}
		sigma[s] = 1;
		d[s] = 0;


		queue<int> Q;
		Q.push(s);  // maybe push_back

		while (!Q.empty())
		{
			int v = Q.front();
			Q.pop();
			S.push(v);

			// move to next neighbor
			int w = 0;

			while (w < data.size())
			{
				// find neighbor
				while (w < data.size() && this->operator ()(v,w) == 0)
					w++;

				// if no neigh exit
				if (w >= data.size())
					break;

				if (d[w] < 0)
				{
					Q.push(w);
					d[w] = d[v] + 1;
				}

				if (d[w] == d[v] + 1)
				{
					sigma[w] = sigma[w] + sigma[v];
					P[w].push_back(v);
				}

				w++; // shift to next
			}


		}

		for (int j = 0; j < data.size(); j++)
			delta[j] = 0.0;

		#if (DEBUG)
			cout << "Sigmas:" << endl;
			for (int j = 0; j < data.size(); j++)
				cout << sigma[j] << " ";
			cout << endl;
		#endif


		while (!S.empty())
		{
			int w = S.top();
			S.pop();
			list<int>::iterator it;

			#if (DEBUG)
				cout << "Prvek:" << w << endl;
			#endif

			for (it = P[w].begin() ; it != P[w].end(); it++)
			{
				int v = *it;  // int v = (int) *it
				delta[v] = delta[v] + ((long double)sigma[v]/(long double)sigma[w])*(1.0+delta[w]);

				#if (DEBUG)
					cout << "\t "<< delta[v] << "=" << sigma[v] << "/" << sigma[w] << "*(1 + " << delta[w] << ")" << endl;
					cout << "\t Cb = "<< betweenessVector[w] << endl;
				#endif
			}

			if (w != s)
			{
				betweenessVector[w] = betweenessVector[w] + delta[w];
			}
		}

		// delete aux data
		for (int i = 0;  i < data.size(); i++)
			P[i].clear();
	} /*-- End of parallel for --*/


	double sum = 0.0;
	for (int i = 0; i < data.size(); i++)
		sum += betweenessVector[i];

	delete[] P;
	delete sigma;
	delete d;
	delete delta;

	long double result = (1/((double) data.size()))*sum;

	return result;
}


double* Graph::getBetweenessData()
{
	if (betweenessVector == NULL)
	{
		betweeness();
	}

	betweenessGet = true;

	return betweenessVector;
}

// double* Graph::getRandWalkBetweenessData()
// {
// 	if (randWalkBetweenessVector == NULL)
// 	{
// 		randWalkBetweeness();
// 	}

// 	randWalkBetweenessGet = true;

// 	return randWalkBetweenessVector;
// }

// double* Graph::getEigenvectorBetweenessData()
// {
// 	if (eigenvectorBetweenessVector == NULL)
// 	{
// 		eigenvectorBetweeness();
// 	}

// 	eigenvectorBetweenessGet = true;

// 	return eigenvectorBetweenessVector;
// }

double* Graph::getClusteringData()
{
	if (clusteringVector == NULL)
	{
		clusteringCoeficient();
	}

	clusteringGet = true;

	return clusteringVector;
}

int* Graph::getNodeDegrees()
{
	if (degrees == NULL)
	{
		nodeDegrees();
	}

	degreesGet = true;

	return degrees;
}

double* Graph::getClosenessData()
{
	// TODO
	if (closenessVector == NULL)
	{
		closeness();
	}

	closenessGet = true;

	return closenessVector;
}

int* Graph::getDistanceMatrixData()
{
	if (!D->specified())
	{
		distanceMatrix();
	}

	dGet = true;

	// TODO
	return NULL;
}

double* Graph::getNearestNeighbors()
{
	if (nearestNeighbors == NULL)
	{
		nodeNearestNeighbors();
	}

	nnGet = true;

	return nearestNeighbors;
}

int Graph::getComponentMatrices(char*** matrices, int*** indices, int** sizes, int*** subdegrees)
{
	// calculate components with data set in componentList
	components();

	*matrices = new char*[componentsList->size()];
	*indices = new int*[componentsList->size()];
	*sizes = new int[componentsList->size()];
	*subdegrees = new int*[componentsList->size()];

	for (size_t i = 0; i < componentsList->size(); i++)
	{
		vector<int> alist = (*componentsList)[i];
		//  get component
		int n = alist.size();

		// allocate corresponding adjacency matrix
		(*matrices)[i] = new char[n*(n+1)/2];
		(*indices)[i] = new int[n];
		(*sizes)[i] = n;

		// fill indices array
		std::vector<int>::iterator it;
		int j = 0;
		for (it = alist.begin(); it != alist.end(); it++)
		{
			(*indices)[i][j++] = *it;
		}

		// fill matrix
		int l = 0;
		for (j = 0; j < n; j++)
		{
			for (int k = j; k < n; k++)
			{
				(*matrices)[i][l++] = this->operator ()((*indices)[i][j],(*indices)[i][k]);
			}
		}

		(*subdegrees)[i] = new int[n];
		for (j = 0; j < n; j++)
		{
			int jrow = j*n - (j*(j+1)/2);
			(*subdegrees)[i][j] = 0;
			for (int k = 0; k < n; k++)
			{
				if (j <= k)
				{
					(*subdegrees)[i][j] += (((*matrices)[i][jrow + k] > 0) ? 1:0);
				}
				else
				{
					(*subdegrees)[i][j] += (((*matrices)[i][k*n - (k*(k+1)/2) + j] > 0) ? 1:0);
				}
			}
		}
	}

//	for (int i = 0; i < componentsList->size(); i++)
//	{
//		cout << "Component " << i << " :" << endl;
//		cout << "Indices:" << endl;
//		printVector((*indices)[i], (*sizes)[i]);
//		cout << endl;
//		cout << "Matrix:" << endl;
//		printMatrix((*matrices)[i],(*sizes)[i]);
//		cout << endl;
//		cout << "Degrees:" << endl;
//		printVector((*subdegrees)[i], (*sizes)[i]);
//		cout << endl;
//		cout << "-------------------------------------" << endl;
//		cout << endl;
//	}


	return 0;
}

double* Graph::getComponentDataMat(int &numComp)
{
	if (componentsList == NULL)
	{
		components();
	}

	// data first dimension is threshold and second contain component matrix
	int compNum = componentsList->size();
	numComp = compNum;
	int numNodes = data.size();
	int clen = numNodes*compNum;
	// matrix holding vertices for all components
	double* componentsMat = new double[clen];

	// zero an array
	for (int j = 0; j < clen; j++)
		componentsMat[j] = 0.0;

	// iterate components
	for (int j = 0; j < compNum; j++)
	{
		for (size_t k = 0; k < (*componentsList)[j].size(); k++)
		{
			int numIdx = (*componentsList)[j][k];
			componentsMat[numIdx*compNum + j] = 1.0;
		}
	}

	return componentsMat;
}

vector<vector<int> >* Graph::getComponentsData()
{
	if (componentsList == NULL)
	{
		components();
	}

	componentsGet = true;

	return componentsList;
}

int Graph::components()
{
	componentsList = new vector<vector<int>  >();
	visited = new bool[data.size()];
	for (int i = 0; i < data.size(); i++)
		visited[i] = false;


	componentIndex = -1;
	for (int i = 0; i < data.size(); i++)
	{
		if (visited[i] == false)
		{
			componentIndex++;
			componentsList->push_back(vector<int>());

			visit(i);
		}
	}


	return componentIndex+1;
}

int Graph::visit(int i)
{
	visited[i] = true;
	(*componentsList)[componentIndex].push_back(i);
	for (int j = 0; j < data.size(); j++)
	{
		if (this->operator ()(i,j) && visited[j] == false)
		{
			visit(j);
		}
	}
	return 0;
}


Graph* Graph::sampleErdosRenyi()
{
	// compute average degree
	if (averageDegree == NO_DEGREE)
	{
		degrees = getNodeDegrees();
		int sum = 0;

		for (int i = 0; i < data.size(); i++)
		{
			sum += degrees[i];
		}

		averageDegree = sum / (double) data.size();
	}

	// compute probability
	double p = averageDegree / (double) (data.size()*data.size() - data.size());

	// generate data structure
	int size = data.size()*(data.size()+1)/2;
	char* mat = new char[size];
	srand(time(NULL));

	// fill data into structure
	for (int i = 0; i < size; i++)
	{
		double toss = rand() / (double) RAND_MAX;
		if (toss > p)
			mat[i] = 1;
		else
			mat[i] = 0;
	}

	return NULL;//new Graph(mat,data.size(),data.size());
}

double Graph::smallWorldIndex()
{
	// compute average clustering coefficient and average path data.len()
	double C = clusteringCoeficient();
	double L = averageShortestPath();

	// get corresponding E-R graph and compute C_er, l_er
	Graph* erGraph = sampleErdosRenyi();
	double Cer = erGraph->clusteringCoeficient();
	double Ler = erGraph->averageShortestPath();

	double gamma = C / Cer;
	double lambda = L / Ler;
	double S = gamma / lambda;

	return S;
}
