#include <math.h>
#include <matrix.h>
#include <mex.h>
#include <stdio.h>
#include <string.h>
#include <limits>
#include "NetworksFunctionsInterface.h"

// matlab entry point
void retrieve_data( const mxArray* matptr, double*& data, int& dim1, int& dim2){
    // retrieve pointer from the MX form
    data = mxGetPr(matptr);
    
    // check that I actually received something
    if( data == NULL )
        mexErrMsgTxt("vararg{2} must be a [kxN] matrix of data\n");
    
    // retrieve amount of points
    dim1 = mxGetM(matptr);
    dim2 = mxGetN(matptr);
}

void mexFunction(int nlhs, mxArray * plhs[], int nrhs, const mxArray * prhs[]){   
	// check input
	if( nrhs < 1 || !mxIsNumeric(prhs[0]) )
		mexErrMsgTxt("Correct arguments are matrix [NxN] and optionaly threshold [1].\n");
	
    // vector data by column - for symmetric matrix the same
    double* data;
    int dim1;
    int dim2;
    retrieve_data( prhs[0], data, dim1, dim2 );
    
    double assort_coef = -1;
    if (nrhs > 1)
    {
        double* threshold = mxGetPr(prhs[1]);
        assort_coef = assortativity_binary(data, dim1, *threshold);
    }
    else
    {
        ;
        //BC = betweenneess_weighted(data, dim1);
    }
    
    // copy results
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    double* pointer_to_result = mxGetPr(plhs[0]);
    pointer_to_result[ 0 ] = assort_coef;
}
