function [ BC ] = ndw_betweenness_wei(A)
%% [ BC ] = ndw_betweenness_wei(A)
% Betweenness centrality for weighted matrices (graphs). 
%
% Parameters:
%       A ... weighted adjacency matrix
%
% Output:
%       BC ... shortest path betweenness centrality computed 
%
% Algorithm:
%       Brandes (2001) J Math Sociol 25:163-177
%
% Author: David Hartman
%         hartman@cs.cas.cz
%%
    BC = ndw_betweenness(A);

end

