%% [ Cp, D ] = ndw_charpath( M, param )
% Components of graph given by adjacency matrix or threshold
%
% Parameters:
%       A ... Matrix that represents adjacency matrix or distance matrix -
%             depends on following parameter
%       param ... Parameter that drive computation. It can have values:
%                 1) none   ... M is considered as any (weighted or 
%                               unweighted) adjacency matrix (graph) and 
%                               distance matrix and efficiency are computed
%                               or
%                 2) 'dist' ... M is considered as a distance matrix; only
%                               efficiency is computed or
%                 3) number ... M is considered as weighted adjacency 
%                               matrix (graph) and param is considered as 
%                               threshold, then distance matrix for 
%                               graph is computed.
%
% Output:
%       Cp ... Characteristic path
%       D ... Distance matrix
%
% Example use:
%       from weighted or unweighted adjacency
%       [efficiency, distance_matrix] = ndw_charpath(adjacency)
%       from weighted adjacency with threshold
%       [efficiency, distance_matrix] = ndw_charpath(adjacency, 0.4)
%
% Algorithm:
%       Watts, D.J., Strogatz, S.H. (1998) Nature 393:440-442
%       - for more components algorithm exclude pair of nodes with no path
%       and adjust normalization accordingly.
%
% Author: David Hartman
%         hartman@cs.cas.cz
%%



