function [ deg ] = ndw_degrees(A,threshold)
%% [ BC ] = ndw_betweenness_bin(A,threshold)
% Degrees of vertices of given weighted matrix after applying threshold. 
% If threshold is not given the matrix is considered as binary.
%
% Parameters:
%       A ... adjacency matrix, possibly weighted - if threshold is given,
%             otherwise binary
%       threshold ... threshold that should be applied to this matrix. If
%                     not given matrix is considered as binary.
% Output:
%       deg ... node degrees
%
% Author: David Hartman
%         hartman@cs.cas.cz
%%
    if (nargin > 1)
        B = (A > threshold) .* 1;
        deg = sum(B);
    else
        deg = sum(A);

end

