%% [ E, D ] = ndw_efficiency( M, param )
% Components of graph given by adjacency matrix or threshold
%
% Parameters:
%       A ... Matrix that represents adjacency matrix or distance matrix -
%             depends on following parameter
%       param ... Parameter that drive computation. It can have values:
%                 1) none   ... M is considered as any (weighted or 
%                               unweighted) adjacency matrix (graph) and 
%                               distance matrix and efficiency are computed
%                               or
%                 2) 'dist' ... M is considered as a distance matrix; only
%                               efficiency is computed or
%                 3) number ... M is considered as weighted adjacency 
%                               matrix (graph) and param is considered as 
%                               threshold, then distance matrix for 
%                               graph is computed.
%
% Output:
%       E ... Efficiency
%       D ... Distance matrix
%
% Example use:
%       from weighted or unweighted adjacency
%       [efficiency, distance_matrix] = ndw_efficiency(adjacency)
%       from weighted adjacency with threshold
%       [efficiency, distance_matrix] = ndw_efficiency(adjacency, 0.4)
%
% Algorithm:
%       Latora and Marchiori (2001) Phys Rev Lett 87:198701.
%
% Author: David Hartman
%         hartman@cs.cas.cz
%%



