#include <cstring>
#include <math.h>
#include <matrix.h>
#include <mex.h>
#include "NetworksFunctionsInterface.h"
#include "Graph.h"
#include "WeightedGraph.h"

#define A_IN prhs[0]
#define G_OUT plhs[0]

void mexFunction(int nlhs, mxArray * plhs[], int nrhs, const mxArray * prhs[]){   
    
    int * A;

    /* check input parameters */
    if(nrhs != 1)
    {
        mexErrMsgTxt("One input argument is required: the adjacency matrix.");
    }
    else if(nlhs != 1)
    {
        mexErrMsgTxt("One output argument is required: the graph handle.");
    }
    
    /* check square matrix */
    nrows = mxGetM(A_IN);
    ncols = mxGetN(A_IN);
    if (!mxIsInt32(A_IN) || (nrows != ncols))
    {
        mexErrMsgTxt("Adjacency matrix must be a square integer matrix.");
    }

    /* get pointer to input */
    A = (int*)mxGetData(A_IN);
    
    BC_OUT = mxCreateDoubleMatrix(g->n, 1, mxREAL);
    bc = mxGetPr(BC_OUT);
    
    /* run BC from all sources */
    vertex_betweenness_centrality(g, bc, g->n);
}
